Imports System.Text

Namespace Derrick.Web
	Public Class Request
		Public Method As String
		Public Url As String
		Public Version As String
		Public Body As String
		Public ContentLength As Integer
		Public Headers As New Dictionary(Of String, String)

		Private _traceSwitch As New TraceSwitch("TraceLevelSwitch", "COMET Request.")

		Public Function HasContent() As Boolean
			If Headers.ContainsKey("Content-Length") Then
				ContentLength = Integer.Parse(Headers("Content-Length"))
				Return True
			End If
			Return False
		End Function

		Public Function VerifyAuth(ByVal auth As AuthConfig) As Boolean
            'return true //added by DLau - June 5, 2012

			If auth.Type = AuthType.Basic Then
				Dim pair() As String
				If Headers.ContainsKey("Authorization") Then
					pair = Headers("Authorization").Split(" "c)
					If pair.Length = 2 Then
                        'Dim temp As String = Util.DecodeBase64(pair1)
                        'If pair0 = "Basic" AndAlso Util.DecodeBase64(pair1) = auth.Username & ":" & auth.Password Then

                        'Return True

                        'Else

                        ' Return False

                        'End If

                        If Not pair(0).Equals("Basic") Then
                            Return False
                        End If

                        Dim usernamePasswordPair As String = Util.DecodeBase64(pair(1))
                        If String.IsNullOrEmpty(usernamePasswordPair) Then
                            Return False
                        End If
                        Trace.WriteLineIf(_traceSwitch.TraceVerbose, "Client username/password pair is " & usernamePasswordPair & ".")
                        If usernamePasswordPair.Equals(auth.Username & ":" & auth.Password) Then
                            Return True
                        End If
                        Return False
                    Else
                        Return False
                    End If
                Else
                    Trace.WriteLineIf(_traceSwitch.TraceVerbose, "Client header doesn't contain Authorization key.")
                    Return False
                End If
            ElseIf auth.Type = AuthType.Digest Then
                'TODO: Handle digest authenticaion
                Return False
            Else
                Return True
            End If
		End Function
	End Class
End Namespace
