Imports System.Threading
Imports System.Text
Imports System.Net
Imports System.Net.Sockets
Imports System.Collections
Imports System.IO

Namespace Derrick.Web
	Friend Class WIServer
		Inherits Server

		Private config As WebInterfaceConfig

		Public Sub New(ByVal c As WebInterfaceConfig)
			MyBase.New(Dns.GetHostEntry(IPAddress.Parse(c.BindTo)).AddressList(0), c.Port, c.Authentication)
			config = c
		End Sub

		Public Overrides Function HandleRequest(ByVal request As Request, ByVal lastUpdate As Date, ByVal cometClient As Client) As Response
			Console.WriteLine("WIServer HandleRequest. " & request.Url)

			Dim pos As Integer = 0
			Dim doc As String = request.Url
			pos = doc.IndexOf("//")
			If pos >= 0 Then
				doc = doc.Substring(pos + 2, doc.Length - pos - 2)
			End If
			pos = doc.IndexOf("/")
			If pos = 0 Then
				doc = doc.Substring(pos + 1, doc.Length - pos - 1)
			End If
			pos = doc.IndexOf("?")
			If pos >= 0 Then
				doc = doc.Substring(0, pos + 1)
			End If
			If doc = "" Then
				doc = "index.html"
			End If

			Dim f As New FileInfo(config.WWWDir & doc)

			Return Response.GetFileResponse(f, request.Url)
		End Function

		Public Overrides Sub BroadcastMessage(ByVal sender As Object, ByVal args As SendMessageEventArgs)
            'throw new NotImplementedException
			Exit Sub
		End Sub
	End Class
End Namespace
