Imports System.Threading
Imports System.Text
Imports System.Net
Imports System.Net.Sockets
Imports System.IO
Imports System.Xml
Imports System.Xml.Serialization

Namespace Derrick.Web
	Public Class AppConfig
		Public ServerInterface As ServerInterfaceConfig
		Public ClientInterface As ClientInterfaceConfig
		Public WebInterface As WebInterfaceConfig

		Public Shared Function LoadConfig(ByVal file As String) As AppConfig
			Dim _traceSwitch As New TraceSwitch("TraceLevelSwitch", "Comet Trace")

			Dim c As AppConfig = Nothing
			Try
				Using fs As New FileStream(file, FileMode.Open)
					Dim serializer As New XmlSerializer(GetType(AppConfig))
					c = CType(serializer.Deserialize(fs), AppConfig)
				End Using
			Catch ex As Exception
				Trace.WriteLineIf(_traceSwitch.TraceError, ex.ToString)
			End Try

			Return c
		End Function

		Public Shared Sub BuildNewConfigFile(ByVal file As String)
			Dim c As New AppConfig

			c.ClientInterface = New ClientInterfaceConfig
			c.ClientInterface.Authentication = New AuthConfig
			c.ClientInterface.Authentication.Type = AuthType.None
			c.ClientInterface.Authentication.Realm = "Derrick Comet Client Interface"
			c.ClientInterface.Authentication.Username = "none"
			c.ClientInterface.Authentication.Password = "none"

			c.WebInterface = New WebInterfaceConfig
			c.WebInterface.Authentication = New AuthConfig
			c.WebInterface.Authentication.Type = AuthType.Basic
			c.WebInterface.Authentication.Realm = "Derrick Comet Web Interface"
			c.WebInterface.Authentication.Username = "cometbox"
			c.WebInterface.Authentication.Password = "cometbox123"

			c.ServerInterface = New ServerInterfaceConfig
			c.ServerInterface.Authentication = New AuthConfig
			c.ServerInterface.Authentication.Type = AuthType.Basic
			c.ServerInterface.Authentication.Realm = "Derrick Comet Server Interface"
			c.ServerInterface.Authentication.Username = "server"
			c.ServerInterface.Authentication.Password = "server123"
			c.ServerInterface.AcceptedIPs = New String() {"127.0.0.1"}

			Using fs As New FileStream(file, FileMode.Create)
				Dim serializer As New XmlSerializer(GetType(AppConfig))
				serializer.Serialize(fs, c)
				fs.Close()
			End Using
		End Sub
	End Class
End Namespace
