Imports System.Threading
Imports System.Text
Imports System.Net
Imports System.Net.Sockets
Imports System.Collections
Imports System.IO
Imports System.Xml
Imports System.Xml.Serialization
Imports System.Configuration
Imports System.Messaging
Imports System.Data.OleDb
Imports Derrick.Web

'Imports System.Web.Script.Serialization.JavaScriptSerializer

Namespace Derrick.Web
	Public Class SIServer
		Inherits Server

		Private config As ServerInterfaceConfig

		Public Sub New(ByVal c As ServerInterfaceConfig)
			MyBase.New(Dns.GetHostEntry(IPAddress.Parse(c.BindTo)).AddressList(0), c.Port, c.Authentication)
			config = c
		End Sub

		Public Overrides Function HandleRequest(ByVal request As Request, ByVal lastUpdate As Date, ByVal cometClient As Client) As Response
			If _traceSwitch Is Nothing Then
				_traceSwitch = New TraceSwitch("TraceLevelSwitch", "Comet Tracing")
			End If

			'''TO DO: add in method to send response in JSON
			'''Derrick Lau - Feb. 3, 2012
            'Console.WriteLine("SIServer HandleRequest. " & request.Url)
			Trace.WriteLine("SIServer HandleRequest. " & request.Url)

            'Console.WriteLine("---")
			Trace.WriteLine("---")
            'Console.WriteLine("\""& request.Body & "\"")
			Trace.WriteLine("""" & request.Body & """")
            'Console.WriteLine("---")
			Trace.WriteLine("---")

			Trace.WriteLineIf(_traceSwitch.TraceInfo, "Inside SIServer.HandleRequest...")

			Try
'				#Region "Process HTTP message as XML"
				'Picks up message from HTTP:
				Dim s As New XmlSerializer(GetType(SIRequest))

				Dim mem As New MemoryStream
				mem.Write(System.Text.Encoding.ASCII.GetBytes(request.Body), 0, request.Body.Length)
				mem.Seek(0, 0)

				'Loads message into object for processing.
				Dim data As SIRequest = CType(s.Deserialize(mem), SIRequest)
'				#End Region ' Process HTTP message as XML

'				#Region "Process HTTP message as JSON"

'				#End Region ' Process HTTP message as JSON

				Dim responseMsg As String = String.Empty

				Dim responseFormat As MessageFormat

				If request.Headers("Content-Type").Contains("json") Then
					responseFormat = MessageFormat.json
				ElseIf request.Headers("Content-Type").Contains("xml") Then
					responseFormat = MessageFormat.xml
				Else
					responseFormat = MessageFormat.text
				End If

				Return Response.GetHtmlResponse(responseMsg, QueueMessage.Instance.LastUpdated, responseFormat)
			Catch ex As Exception
				Console.WriteLine("Error parsing xml: " & ex.Message)
				Trace.WriteLineIf(_traceSwitch.TraceError, "Inside SIServer.HandleRequest.  Exception thrown: " & ex.ToString)
				Trace.Flush()
				Return Response.GetHtmlResponse("Error parsing xml: " & ex.Message, QueueMessage.Instance.LastUpdated, MessageFormat.text)
			End Try
		End Function

		Public Overrides Sub BroadcastMessage(ByVal sender As Object, ByVal args As SendMessageEventArgs)
            'throw new NotImplementedException
            Trace.WriteLineIf(_traceSwitch.TraceVerbose, "Broadcasting message " & args.Message & " to all clients.")

			Dim numOfClients As Integer = clients.Count
			For i  = 0 To numOfClients - 1
				clients(i).SendResponse(args)
			Next i
		End Sub

		<XmlRoot("Request")>
		Public Class SIRequest
			Public Enum CommandType
				Queue
				Remove
			End Enum

			Public Structure MessageData
				Public Message As String
			End Structure

			Public Command As CommandType = CommandType.Queue
			Public User As String = ""

			<XmlElement("Message")>
			Public Messages() As String
		End Class
	End Class
End Namespace
